package org.example.proyectofinalmacedonia;

import java.net.URL;
import java.text.DecimalFormat;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

import android.app.Activity;
import android.app.ProgressDialog;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TextView;



public class ConversorDivisasMultiples extends Activity {
	
    private EditText entrada;
    private TextView salida;   
    
    private Spinner tipo;
    TipoConversionDivisas tipoConversionSel;
    
    private String valor1  = "";
    private String valor2  = "";
    private String valor3  = "";
    private String valor4  = "";
    private String valor5  = "";
    private String valor6  = "";
    private String valor7  = "";
    private String valor8  = "";
    private String valor9  = "";
    private String valor10 = "";
    
    private String valorDivisa = "";
    
    boolean actividadDestruida = false;
    

    
    @Override
    public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.conversion_divisas);
       
    	entrada = (EditText) this.findViewById(R.id.entrada);
    	salida  = (TextView) this.findViewById(R.id.salida);
    	
    	
        tipo = (Spinner) this.findViewById(R.id.tipo);
        ArrayAdapter<String> adaptador = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item, TipoConversionDivisas.getNombres());
        adaptador.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        tipo.setAdapter(adaptador);
        tipo.setSelection(TipoConversionDivisas.EUR_DOL.ordinal());
    	
    	
    	Button boton1 = (Button) this.findViewById(R.id.calc_button1);
    	valor1 = boton1.getTag().toString();
    	boton1.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor1);
	        }
	    });
    	
    	
    	Button boton2 = (Button) this.findViewById(R.id.calc_button2);
    	valor2 = boton2.getTag().toString();
    	boton2.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor2);
	        }
	    });
	    
    	
    	Button boton3 = (Button) this.findViewById(R.id.calc_button3);
    	valor3 = boton3.getTag().toString();
    	boton3.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor3);
	        }
	    });
	    
    	
    	Button boton4 = (Button) this.findViewById(R.id.calc_button4);
    	valor4 = boton4.getTag().toString();
    	boton4.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor4);
	        }
	    });
	    
    	
    	Button boton5 = (Button) this.findViewById(R.id.calc_button5);
    	valor5 = boton5.getTag().toString();
    	boton5.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor5);
	        }
	    });
	    
    	
    	Button boton6 = (Button) this.findViewById(R.id.calc_button6);
    	valor6 = boton6.getTag().toString();
    	boton6.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor6);
	        }
	    });
	    
    	
    	Button boton7 = (Button) this.findViewById(R.id.calc_button7);
    	valor7 = boton7.getTag().toString();
    	boton7.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor7);
	        }
	    });
	    
    	
    	Button boton8 = (Button) this.findViewById(R.id.calc_button8);
    	valor8 = boton8.getTag().toString();
    	boton8.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor8);
	        }
	    });
	    
    	
    	Button boton9 = (Button) this.findViewById(R.id.calc_button9);
    	valor9 = boton9.getTag().toString();
    	boton9.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor9);
	        }
	    });
	    
    	
    	Button boton10 = (Button) this.findViewById(R.id.calc_button10);
    	valor10 = boton10.getTag().toString();
    	boton10.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            pulsaNumero(valor10);
	        }
	    });
    	
    	
    	Button boton11 = (Button) this.findViewById(R.id.calc_button11);
    	boton11.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            convertirAEuros();
	        }
	    });
    	
    	
    	Button boton12 = (Button) this.findViewById(R.id.calc_button12);
    	boton12.setOnClickListener(new OnClickListener() {
	        public void onClick(View view) {
	            borrar();
	        }
	    });
	    
    }
    
    
    
    public void pulsaNumero(String numero) {
    	entrada.setText(String.valueOf(entrada.getText().toString() + numero));
    }
    
    
    
    public void convertirAEuros() {
    	if (entrada.getText().toString().length() > 0) {
        	String cantidad = entrada.getText().toString();
        	
        	tipoConversionSel = TipoConversionDivisas.values()[tipo.getSelectedItemPosition()];
        	
        	new BuscarConversionEnWebserviceX().execute(cantidad);
    	} else {
    		salida.setText("");
    	}
    }
    
    
    
    public void borrar() {
    	entrada.setText("");
    	salida.setText("");
    }
    
    
    String var;
    int pos;

     

	@Override
	protected void onSaveInstanceState(Bundle guardarEstado) {
		super.onSaveInstanceState(guardarEstado);
		guardarEstado.putString("valorDivisa", valorDivisa);

		actividadDestruida = true;
	}

	
	
	@Override
	protected void onRestoreInstanceState(Bundle recEstado) {
		super.onRestoreInstanceState(recEstado);
		valorDivisa = recEstado.getString("valorDivisa");
		
		calcularDivisa();
	}
    
    
    
	String resultadosConversor(String cantidad) throws Exception {
		URL url = new URL("http://www.webservicex.net/CurrencyConvertor.asmx/ConversionRate?FromCurrency=" + 
						   tipoConversionSel.getDivisaOrigen() + "&ToCurrency=" + 
						   tipoConversionSel.getDivisaDestino());
		
		SAXParserFactory fabrica = SAXParserFactory.newInstance();
		SAXParser parser = fabrica.newSAXParser();

		XMLReader lector = parser.getXMLReader();

		ManejadorXML manejadorXML = new ManejadorXML();

		lector.setContentHandler(manejadorXML);
		lector.parse(new InputSource(url.openStream()));

		return manejadorXML.getTotal();
	}
	
	
	
	class BuscarConversionEnWebserviceX extends AsyncTask<String, Void, String> {

		private ProgressDialog progreso;

		@Override
		protected void onPreExecute() {
			progreso = new ProgressDialog(ConversorDivisasMultiples.this);
			progreso.setProgressStyle(ProgressDialog.STYLE_SPINNER);
			progreso.setMessage("Accediendo a WebserviceX...");
			progreso.setCancelable(false);
			progreso.show();
			
			actividadDestruida = false;
		}

		@Override
		protected String doInBackground(String... palabras) {
			try {
				return resultadosConversor(palabras[0]);
			} catch (Exception e) {
				cancel(true);
				Log.e("HTTP", e.getMessage(), e);
				return null;
			}
		}

		@Override
		protected void onPostExecute(String res) {
			if (!actividadDestruida) {
				progreso.dismiss();
				valorDivisa = res;
				calcularDivisa();
			}
		}

		@Override
		protected void onCancelled() {
			progreso.dismiss();
			valorDivisa = "-1";
		}
	}
	
	
	
	private void calcularDivisa() {
    	if (entrada.getText().toString().length() > 0 && valorDivisa != "" && valorDivisa != "-1") {
    		DecimalFormat formateador = new DecimalFormat("########.###");
    		salida.setText(String.valueOf(formateador.format(Float.parseFloat(entrada.getText().toString())*Float.parseFloat(valorDivisa)))); 
    	}
	}
	
	
	
	public class ManejadorXML extends DefaultHandler {

		private String total;
		private StringBuilder cadena = new StringBuilder();
		

		public String getTotal() {
			return total;
		}

		@Override
		public void startElement(String uri, String nombreLocal, String nombreCualif, Attributes atributos) throws SAXException {
			cadena.setLength(0);
		}

		@Override
		public void characters(char ch[], int comienzo, int lon) {
			cadena.append(ch, comienzo, lon);
		}

		@Override
		public void endElement(String uri, String nombreLocal, String nombreCualif) throws SAXException {
			if (nombreLocal.equals("double")) {
				total = cadena.toString();
			}
		}
	}
    
}
