package org.example.proyectofinalmacedonia;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.TelephonyManager;


public class ReceptorLlamadas extends BroadcastReceiver {

	@Override
	public void onReceive(Context context, Intent intent) {
		// Sacamos informacin de la intencin

		String estado = "", numero = "";
		Bundle extras = intent.getExtras();

		if (extras != null) {
			estado = extras.getString(TelephonyManager.EXTRA_STATE);

			if (estado.equals(TelephonyManager.EXTRA_STATE_RINGING)) {
				numero = extras.getString(TelephonyManager.EXTRA_INCOMING_NUMBER);
				String info = estado + " " + numero;
				
				Intent intencionLlamada = new Intent(context, ServicioLlamada.class);
				intencionLlamada.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
					
				intencionLlamada.putExtra("LLAMADA_INFO", info);
			
				context.startService(intencionLlamada);
			}
		}
	}

}
