package org.example.proyectofinalmacedonia;


import android.app.Activity;
import android.content.Context;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;
import android.view.ViewGroup;
import android.view.WindowManager.LayoutParams;
import android.view.inputmethod.InputMethodManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.PopupWindow;
import android.widget.ScrollView;
import android.widget.TextView;


 
public class Encriptar extends Fragment implements OnTouchListener {
	
	private boolean guardado = false;
	public static boolean botonAceptar = false;
	public static boolean esperandoPopup = false;
	
	public static TextView encr;
	
	View vista;
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    } 

    
    
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
    	vista = inflater.inflate(R.layout.encriptar, container, false);
    	
        ScrollView scroll = (ScrollView) vista.findViewById(R.id.scrollEncriptar);
        scroll.setOnTouchListener(this);
        
        EditText edit = (EditText) vista.findViewById(R.id.textoEncriptar);
        edit.setFocusableInTouchMode(true);
        edit.requestFocus();
        
        encr = (TextView) vista.findViewById(R.id.textoEncriptado);
        encr.setText("");
        
        TextWatcher fieldValidatorTextWatcher = new TextWatcher() {
            @Override
            public void afterTextChanged(Editable s) {
            }

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
            	if (count > 0) {
					EncriptarClase encriptar = new EncriptarClase(EncriptarClase.clave);
					String encriptado = encriptar.encrypt(s.toString());
					encr.setText(encriptado);
            	}
            }
 
        };
        
        edit.addTextChangedListener(fieldValidatorTextWatcher);
  
        
        edit.setOnKeyListener(new View.OnKeyListener(){
			@Override
			public boolean onKey(View v, int keyCode, KeyEvent event) {
				
				if (keyCode == 66 && !guardado){
					
					TextView text = ((TextView) vista.findViewById(R.id.textoEncriptado));
					String textString = text.getText().toString();
					
					if (textString.length() > 0) {
						guardado = true;
						
						MensajeDataSource msgDataSource = new MensajeDataSource(getActivity().getBaseContext());
						msgDataSource.open();
						msgDataSource.createMensaje(textString, getActivity().getBaseContext());
						msgDataSource.close();
						
				        MediaPlayer mp = MediaPlayer.create(getActivity(), R.raw.encriptado);
				        mp.start();
		                while (mp.isPlaying()){
		                }
		                mp.release();
						try {
							mensaje();
						} catch (Throwable e) {
							e.printStackTrace();
						}
						return true;
					}
				}
				return false;
			}
		});
        
        return vista;
    }

    
    
    public void mensaje(){
    	LayoutInflater layoutInflater = (LayoutInflater) getActivity().getBaseContext().getSystemService(Activity.LAYOUT_INFLATER_SERVICE);  
    	View popupView = layoutInflater.inflate(R.layout.popup, null);  
                
    	final PopupWindow popupWindow = new PopupWindow(popupView, LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);  
                
        Button btnDismiss = (Button)popupView.findViewById(R.id.btnPopupAceptar);
        
        btnDismiss.setOnClickListener(new Button.OnClickListener() {
	        @Override
	        public void onClick(View v) {
	         popupWindow.dismiss();
	         
	         EditText edit = (EditText) vista.findViewById(R.id.textoEncriptar);
	         edit.setText("");
	         
	         TextView encr = (TextView) vista.findViewById(R.id.textoEncriptado);
	         encr.setText("");
	         
	         guardado=false;
	         
			 InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
			 imm.showSoftInput(edit, InputMethodManager.SHOW_IMPLICIT);
	        }
	    });
        
        Button cancelar = (Button)popupView.findViewById(R.id.btnPopupCancelar);
        
        cancelar.setOnClickListener(new Button.OnClickListener(){
	        @Override
	        public void onClick(View v) {
	        	popupWindow.dismiss();
	        	getActivity().finish();
	        }
	    });
                
        TextView t = (TextView) vista.findViewById(R.id.textoEncriptado);
        popupWindow.showAsDropDown(t, 50, -30);
    }
    
    
    
	@Override
	public boolean onTouch(View v, MotionEvent event) {
		EditText yourEditText= (EditText) vista.findViewById(R.id.textoEncriptar);
		InputMethodManager imm = (InputMethodManager) getActivity().getSystemService(Context.INPUT_METHOD_SERVICE);
		imm.showSoftInput(yourEditText, InputMethodManager.SHOW_IMPLICIT);
		
		return true;
	}
	
}
